<template>
  <b-row id="metadataManagerButtonRowTop" align-h="between">
    <b-col>
      <!-- Input Group with Upload button -->
      <b-input-group id="metadataManagerUploadMenu">
        <b-dropdown
          id="buttonSelectFoldersWrapper"
          size="sm"
          left
          :disabled="uploadDisabled || editableDataUrl"
        >
          <b-dropdown-item
            id="buttonSelectFolder"
            @click="$emit('selectFolders')"
          >
            {{ $t("page.resource.metadataManagerBtnSelectFolders") }}
          </b-dropdown-item>
        </b-dropdown>
        <!-- Select Files Button -->
        <b-button
          v-if="!isGuest"
          id="buttonSelectFiles"
          variant="secondary"
          :placeholder="$t('page.resource.metadataManagerBtnSelectFiles')"
          :disabled="uploadDisabled"
          @click="$emit('selectFiles')"
        >
          {{ $t("page.resource.metadataManagerBtnSelectFiles") }}
        </b-button>
      </b-input-group>
      <b-tooltip
        v-if="uploadDisabled && uploadDisabledReason"
        target="metadataManagerUploadMenu"
        triggers="hover"
        placement="bottom"
        boundary="viewport"
      >
        {{ uploadDisabledReason }}
      </b-tooltip>
      <b-tooltip
        v-if="uploadDisabled && uploadDisabledReason"
        target="buttonSelectFoldersWrapper"
        triggers="hover"
        placement="bottom"
        boundary="viewport"
      >
        {{ uploadDisabledReason }}
      </b-tooltip>
    </b-col>

    <b-col>
      <!-- Input Group with Download button -->
      <b-input-group id="metadataManagerDropDownMenu" class="float-end">
        <b-dropdown
          v-if="!isGuest"
          id="addColumnDropDown"
          size="sm"
          right
          :disabled="!showDetail || shownFiles.length === 0"
        >
          <b-dropdown-item
            v-if="!editableDataUrl && !isGuest && !isGitLab"
            :disabled="
              !showDetail ||
              shownFiles.length === 0 ||
              !currentFolderContent ||
              currentFolderContent.type !== 'Leaf'
            "
            @click="$emit('copyUrl')"
          >
            {{ $t("page.resource.metadataManagerBtnCopyLink") }}
          </b-dropdown-item>
          <b-dropdown-item
            :disabled="
              !showDetail || shownFiles.length === 0 || !currentFolderContent
            "
            @click="$emit('downloadMetadata')"
          >
            {{ $t("page.resource.metadataManagerBtnDownloadMetadata") }}
          </b-dropdown-item>
          <b-dropdown-divider
            v-if="!editableDataUrl && !isGuest"
          ></b-dropdown-divider>
          <b-dropdown-item
            v-if="resource.metadataExtraction"
            :disabled="
              !showDetail || shownFiles.length === 0 || !currentFolderContent
            "
            @click="$emit('downloadExtractedMetadata')"
          >
            {{
              $t("page.resource.metadataManagerBtnDownloadExtractedMetadata")
            }}
          </b-dropdown-item>
          <b-dropdown-item
            v-if="showDetail && !isGuest"
            :disabled="
              (resourceTypeInformation && !resourceTypeInformation.canDelete) ||
              readOnly ||
              (resource && resource.archived)
            "
            @click="$emit('showModalDeleteFolderContents')"
          >
            {{ $t("buttons.delete") }}
          </b-dropdown-item>
        </b-dropdown>
        <b-button
          v-if="!editableDataUrl"
          :disabled="
            !showDetail || shownFiles.length === 0 || !currentFolderContent
          "
          @click="$emit('download')"
        >
          {{ $t("buttons.download") }}
        </b-button>
      </b-input-group>
    </b-col>
  </b-row>
</template>

<script lang="ts">
import useProjectStore from "@/modules/project/store";
// import the store for current module
import useResourceStore from "../../../store";
import type { TranslateResult } from "vue-i18n";
import type {
  GitlabBranchDto,
  ResourceDto,
  ResourceTypeInformationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import {
  CoscineResourceTypes,
  type FolderContent,
} from "@/modules/resource/types";

export default defineComponent({
  props: {
    currentFolderContent: {
      default: undefined,
      type: [Object, undefined] as PropType<FolderContent | undefined>,
    },
    editableDataUrl: {
      required: true,
      type: Boolean,
    },
    isUploading: {
      required: true,
      type: Boolean,
    },
    readOnly: {
      required: true,
      type: Boolean,
    },
    resource: {
      required: true,
      type: Object as PropType<ResourceDto>,
    },
    showDetail: {
      required: true,
      type: Boolean,
    },
    shownFiles: {
      required: true,
      type: Array as PropType<FolderContent[]>,
    },
  },
  setup() {
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();

    return { projectStore, resourceStore };
  },
  data() {
    return {
      coscineResourceTypes: CoscineResourceTypes,
      gitlabBranchProps: {} as GitlabBranchDto | undefined,
    };
  },
  computed: {
    isGuest(): boolean | undefined {
      return this.projectStore.currentUserRoleIsGuest;
    },
    uploadDisabled(): boolean {
      return (
        this.isUploading ||
        this.readOnly ||
        this.resource.archived ||
        (this.isGitLab && !this.gitlabBranchProps?.canPush) ||
        false
      );
    },
    uploadDisabledReason(): TranslateResult | null {
      if (this.isUploading)
        return this.$t("page.resource.metadataManagerBtnCantUploadArchived");
      else if (this.readOnly)
        return this.$t("page.resource.metadataManagerBtnCantUploadReadonly");
      else if (this.resource.archived)
        return this.$t("page.resource.metadataManagerBtnCantUploadUploading");
      else if (this.isGitLab && !this.gitlabBranchProps?.canPush)
        return this.$t("resourceType.gitlab.cantPush", {
          branch: this.gitlabBranchProps?.name,
        });
      else return null;
    },
    resourceTypeInformation(): ResourceTypeInformationDto | undefined {
      return this.resourceStore.enabledResourceTypes?.find(
        (resourceType) => resourceType.id === this.resource?.type?.id,
      );
    },
    isGitLab(): boolean {
      return (
        this.resource.type?.generalType ===
        this.coscineResourceTypes.Gitlab.General
      );
    },
  },
  async mounted() {
    if (this.resource.type?.options?.gitLab && this.isGitLab) {
      await this.fetchGitlabBranchInfo();
    }
  },
  methods: {
    async fetchGitlabBranchInfo() {
      const projectId = this.resource.type?.options?.gitLab?.projectId;
      const domain = this.resource.type?.options?.gitLab?.repoUrl;
      const accessToken = this.resource.type?.options?.gitLab?.accessToken;
      const currentBranch = this.resource.type?.options?.gitLab?.branch;
      if (projectId && domain && accessToken && currentBranch) {
        const gitlabBranches =
          await this.resourceStore.getGitlabBranchesForProject(
            projectId,
            domain,
            accessToken,
          );
        if (gitlabBranches) {
          this.gitlabBranchProps = gitlabBranches.find(
            (b) => b.name === currentBranch,
          );
        }
      }
    },
  },
});
</script>

<style scoped>
#metadataManagerButtonRowTop {
  margin-bottom: 5px;
}
#metadataManagerUploadMenu {
  margin-right: 5px;
  width: auto;
}
#metadataManagerUploadMenu button {
  border-radius: 0px;
}
#metadataManagerDropDownMenu {
  margin-right: 5px;
  width: auto;
}
</style>
